
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/time.h>


enum {
//	_xinfreq = 20_000_000,
	_xtlfreq = 20_000_000,
//	_clkfreq = 201_300_000,
	_clkfreq = 242_726_000,
	DEBUG_BAUD = 230_400,
	DOWNLOAD_BAUD = DEBUG_BAUD,

};

//struct __using( "I2C slave v1.2.spin" ) i2cs;
struct __using( "stdlib.spin2" ) lib;


//===================================================================================

void  main( void )
{
    uint32_t  mode, divd, mult, divp;

    _waitms( 200 );
    mode = _clockmode();
    printf( "\n   clkfreq = %d   clkmode = 0x%x\n", _clockfreq(), mode );
    divd = ((mode >> 18) & 0x3f) + 1;
    mult = ((mode >> 8) & 0x3ff) + 1;
    divp = ((mode >> 4) + 1) & 0xf;
    divp = divp ? divp * 2 : 1;
    printf( " DIVD %d   MULT %d   DIVP %d\n", divd, mult, divp );

    _waitms( 200 );
    lib.pllset( _clkfreq );
//    _setbaud( DEBUG_BAUD );
    mode = _clockmode();
    printf( "\n   clkfreq = %d   clkmode = 0x%x\n", _clockfreq(), mode );
    divd = ((mode >> 18) & 0x3f) + 1;
    mult = ((mode >> 8) & 0x3ff) + 1;
    divp = ((mode >> 4) + 1) & 0xf;
    divp = divp ? divp * 2 : 1;
    printf( " DIVD %d   MULT %d   DIVP %d\n", divd, mult, divp );

    for(;;)
    {
        _waitms(200);
        _txraw('.');
    }
}
